public class Point3D {

    private double x, y, z;
    private static int count = 0;

    public Point3D(double x, double y, double z) {
        this.x = x;
        this.y = y;
        this.z = z;
        count = count + 1;
        System.out.println(count + " Point3D created");
    }

    public Point3D rotate(double xy_angle, double yz_angle) {
        double x1 = Rotate2D.getX(x,y,xy_angle);
        double y1 = Rotate2D.getY(x,y,xy_angle);
        double y2 = Rotate2D.getX(y1,z,yz_angle);
        double z2 = Rotate2D.getY(y1,z,yz_angle);
        // return new Point3D(x1,y2,z2);
        x = x1;
        y = y2;
        z = z2;
        return this;
    }

    public Point3D translate(double dx, double dy, double dz) {
        // return new Point3D(x + dx, y + dy, z + dz);
        x = x + dx;
        y = y + dy;
        z = z + dz;
        return this;
    }

    public double getX() { return x; }
    public double getY() { return y; }
    public double getZ() { return z; }

    public Point3D clone() {
        return new Point3D(x,y,z);
    }

}
